; File Name   :	d:\hobby3\z9001-devices\v24g\V24G.KCC
; Format      :	Binary file
; Base Address:	0000h Range: BA80h - C000h Loaded length: 0580h

; Grafikfhiger Druckertreiber
; V24 ber User-PIO

		cpu	z80


PIO1BD		EQU	89H		; PIO1 B Daten Anwenderport
PIO1BS		EQU	8BH		; PIO1 B Kommando Anwenderport


		org 0BB00h

;------------------------------------------------------------------------------
; OS-Rahmen
;------------------------------------------------------------------------------

start:		jp	V24G
name:		db "V24G    ",0
		db    0

;------------------------------------------------------------------------------
; Initialisierung
;------------------------------------------------------------------------------

V24G:		ld	a, 0CFh
		out	(8Bh), a
		ld	a, 80h ; ''
		out	(8Bh), a
		cpl
		out	(89h), a
		ld	hl, init	; Steuercodes f. Initialiserung
		ld	b, 5
		call	DOUTS		; Ausgabe (B) Zeichen
		; Parameter f. ASGN
		ld	bc, ttyl	; TTY-Treiber
		ld	de, name	; "V24G	   "
		ld	hl, 602h	; LIST, LST-Treiber
		ret

;------------------------------------------------------------------------------
; Gerte-Treiber
;------------------------------------------------------------------------------

ttyl:		inc	a		; TTY-Treiber
		ret	z		; FF-init
		dec	a
		jr	nz, ttyl1	; Zeichenausgabe
; A=1 Statusabfrage
status:		in	a, (89h)
		or	7Fh
		cpl
		or	a
		ret
; A=2 Zeichenausgabe C
ttyl1:		ld	a, c		; Zeichenausgabe
		cp	0Eh
		jr	nz, COUT
;
;CTRL/N Bildschirmkopie
		ld	bc, 3C0h
		ld	hl, 0EC00h
		ld	d, 40
ttyl2:		ld	a, (hl)
		push	bc
		cp	' '
		jr	nc, ttyl3
		ld	a, ' '
ttyl3:		ld	c, a
		push	hl
		call	COUT
		pop	hl
		pop	bc
		dec	d
		jr	nz, ttyl4
		push	bc
		ld	c, 0Dh
		call	DOUT		; Zeichenausgabe
		ld	c, 0Ah
		call	DOUT		; Zeichenausgabe
		pop	bc
		ld	d, 40
ttyl4:		cpi
		ret	po
		jr	ttyl2
		
; A=2 Zeichenausgabe C
COUT:		bit	7, c		; Ascii	< 128?
		jr	z, DOUT		; Zeichenausgabe
;
;Grafikzeichenausgabe
		ld	hl, grmode	; Steuercodes f. Grafikmode
		push	bc
		ld	b, 5
		call	DOUTS		; Ausgabe (B) Zeichen
		;		
		pop	bc		; C = Zeichen
		ld	hl, chrset
		xor	a
		sla	c
		sla	c
		rla
		sla	c
		rla
		ld	b, a		; BC = Offs. in Zeichentabelle
		add	hl, bc		; HL = Pos. in Zeichentabelle
		ld	b, 8		; 8 Bytes ausgeben

;------------------------------------------------------------------------------
; Ausgabe (B) Zeichen
;------------------------------------------------------------------------------

DOUTS:		ld	c, (hl)
		push	bc
		call	DOUT		; Zeichenausgabe
		pop	bc
		inc	hl
		djnz	DOUTS		; Ausgabe (B) Zeichen
		ret

;------------------------------------------------------------------------------
; Zeichenausgabe V24
;------------------------------------------------------------------------------

DOUT:		call	status		; Drucker bereit?
		jr	z, DOUT		; Zeichenausgabe
		ld	a, c
		ld	bc, 90Ch
		rla
		di
dout1:		out	(89h), a
		call	dout2
		rra
		djnz	dout1
		or	1
		out	(89h), a
		ei
dout2:		push	bc
dout3:		dec	c
		jr	nz, dout3
		pop	bc
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

ESC		equ	27

; Steuercodes f. Grafikmodus
grmode:		db ESC, '*', 4, 8, 0

; Steuercodes f. Initialiserung
init:		db ESC, '3', 24
		db ESC, 'P'

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------
		
; Zeichensatz 8x8 Pixel, 128 Zeichen ab 80h
chrset:		equ	$
		include	v24g_zs.inc


		end
